//
//  ExamplePersistSQLiteViewController.m
//  ExamplePersistSQLite
//
//  Created by Fernando Nazario on 14/07/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ExamplePersistSQLiteViewController.h"
#import "Customer.h"

@implementation ExamplePersistSQLiteViewController

@synthesize tableViewCustomers;


#pragma mark -
#pragma mark - TableViewDataSource
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
	static NSString *cellIdentifier = @"CellIdentifier";
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
	
	if(!cell)
		cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
	
	Customer *thisCustomer = [customersList objectAtIndex:indexPath.row];
	[cell.textLabel setText:thisCustomer.nameCustomer];
	[cell.detailTextLabel setText:thisCustomer.typeCustomer];
	
	return cell;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
	return [customersList count];
}

- (void) refreshData
{
	customersList = [Customer findAll];
	[tableViewCustomers reloadData];
}

#pragma mark - 
#pragma mark - TableViewDelegate
- (UITableViewCellEditingStyle)tableView:(UITableView *)table editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
	if (indexPath.row == [customersList count])
		return UITableViewCellEditingStyleNone;
	else
		return UITableViewCellEditingStyleDelete;
}

- (void)tableView:(UITableView *)table commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
	if (editingStyle == UITableViewCellEditingStyleDelete)
	{				
		Customer *editCustomer = [customersList objectAtIndex:indexPath.row];
		[editCustomer delete];
		
		[self refreshData];
	}
}

#pragma mark -
#pragma mark IBAction's
- (IBAction) buttonNewCustomerTouched:(id)sender
{
	Customer *newCustomer = [[Customer alloc] init];
	newCustomer.nameCustomer = @"Test Now";
	newCustomer.typeCustomer = @"PJ";
	[newCustomer save];
	
	[self refreshData];
}

- (IBAction) buttonEditTouched:(id)sender
{
	if(editing)
	{
		[tableViewCustomers setEditing:NO];
		editing = NO;
	}
	else
	{
		[tableViewCustomers setEditing:YES];
		editing = YES;
	}
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	
	customersList = [Customer findAll];
	editing = NO;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
	
	customersList = [Customer findAll];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


@end
