//
//  IDatabase.h
//  ExamplePersistSQLite
//
//  Created by Fernando Nazario on 14/07/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <sqlite3.h>

@interface IDatabase : NSObject
{
	NSString *pathToDatabase;
	sqlite3 *_database;
}

@property (nonatomic, strong) NSString *pathToDatabase;
//@property (nonatomic, strong) sqlite3 *_database;

+ (IDatabase *)shared;
- (NSArray *) tables;
- (NSArray *) tableNames;
- (id) initWithPath: (NSString *) filePath;
- (id) initWithFileName: (NSString *) fileName;
- (NSArray *) columnsForTableName: (NSString *) tableName;
- (void) copyValuesFromStatement: (sqlite3_stmt *) statement toRow: (id) row queryInfo: (NSDictionary *) queryInfo columnTypes: (NSArray *) columnTypes columnNames: (NSArray *) columnNames;
- (id) valueFromStatement: (sqlite3_stmt *) statement column: (int) column queryInfo: (NSDictionary *) queryInfo columnTypes: (NSArray *) columnTypes;
- (NSArray *) executeSqlWithParameters: (NSString *) sql, ...;
- (NSArray *) executeSql: (NSString *) sql withParameters: (NSArray *) parameters;
- (NSArray *) executeSql: (NSString *) sql withParameters: (NSArray *) parameters withClassForRow: (Class) rowClass;
- (NSUInteger) lastInsertRowId;

@end
